"""Extending players number

Revision ID: ce63c5bfdc89
Revises: 915bac87ad60
Create Date: 2021-10-07 10:04:00.284086

"""
import sqlalchemy as sa
from alembic import op
from psycopg2.errors import DataException
from sqlalchemy.dialects import postgresql
from sqlalchemy.sql.expression import text

# revision identifiers, used by Alembic.
revision = 'ce63c5bfdc89'
down_revision = '915bac87ad60'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('cell', sa.Column('owner_id', sa.Integer(), nullable=True))
    op.add_column(
        'cell', sa.Column('is_captured', sa.Boolean(), nullable=True)
    )
    op.create_foreign_key(None, 'cell', 'player', ['owner_id'], ['id'])
    op.add_column(
        'game',
        sa.Column('total_players_number', sa.SmallInteger(), nullable=True)
    )

    # Set total_players_number to Game
    connection = op.get_bind()
    connection.execute(text("UPDATE game SET total_players_number=2"))

    # Set owner_id and is_captured to Cell
    connection.execute(text("UPDATE cell SET is_captured=FALSE"))
    connection.execute(
        text(
            "UPDATE cell "
            "SET "
            "owner_id=player.id, "
            "is_captured= CASE"
            "  WHEN "
            "    cell.content::text='dead cross' OR "
            "    cell.content::text='dead zero'"
            "  THEN TRUE "
            "  ELSE FALSE "
            "END "
            "FROM player "
            "WHERE ("
            "  player.virus::text=cell.content::text OR "
            "  (player.virus::text='ZERO' AND cell.content::text='dead cross')"
            "  OR "
            "  (player.virus::text='CROSS' AND cell.content::text='dead zero')"
            ") "
            "AND player.id IN "
            "(SELECT player.id FROM player "
            "JOIN game ON player.game_id=game.id "
            "AND cell.board_id=game.board_id) "
        )
    )

    # Change Virus Enum to Player
    op.execute(
        "CREATE TYPE virus_type AS ENUM('TYPE0', 'TYPE1', 'TYPE2', 'TYPE3')"
    )
    op.execute((
        "ALTER TABLE player ALTER COLUMN virus TYPE virus_type USING "
        "CASE "
        "  WHEN virus::text='CROSS' "
        "  THEN 'TYPE0'::virus_type "
        "  ELSE 'TYPE1'::virus_type "
        "END"
    ))
    op.execute("DROP TYPE player_virus")

    op.create_check_constraint(
        'total_players_number_check',
        'game',
        'total_players_number BETWEEN 2 AND 4'
    )

    op.alter_column('game', 'total_players_number', nullable=False)
    op.alter_column('cell', 'is_captured', nullable=False)
    op.drop_column('cell', 'content')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        'cell',
        sa.Column(
            'content',
            postgresql.ENUM(
                'EMPTY', 'CROSS', 'ZERO', 'DEAD_CROSS', 'DEAD_ZERO',
                name='cellcontent'
            ),
            autoincrement=False,
            nullable=True
        )
    )

    connection = op.get_bind()

    # Check players count in games
    res = connection.execute(
        text("SELECT COUNT(*) FROM game WHERE game.total_players_number>2")
    )
    if res.fetchall()[0][0] > 0:
        raise DataException(
            "Can't downgrade "
            "because database have games with great than 2 players"
        )

    # Set content to Cell
    connection.execute(text("UPDATE cell SET content='EMPTY'::cellcontent"))
    connection.execute(
        text(
            "UPDATE cell "
            "SET "
            "content= CASE"
            "  WHEN "
            "    player.virus::text='TYPE0' AND NOT cell.is_captured "
            "  THEN 'DEAD_ZERO'::cellcontent "
            "  WHEN "
            "    player.virus::text='TYPE1' AND NOT cell.is_captured  "
            "  THEN 'DEAD_CROSS'::cellcontent "
            "  WHEN "
            "    player.virus::text='TYPE0' AND cell.is_captured "
            "  THEN 'CROSS'::cellcontent "
            "  WHEN "
            "    player.virus::text='TYPE1' AND cell.is_captured  "
            "  THEN 'ZERO'::cellcontent "
            "  ELSE 'EMPTY'::cellcontent "
            "END "
            "FROM player "
            "WHERE player.id=cell.owner_id "
        )
    )

    # Change Virus Enum to Player
    op.execute(
        "CREATE TYPE player_virus AS ENUM('CROSS', 'ZERO')"
    )
    op.execute((
        "ALTER TABLE player ALTER COLUMN virus TYPE player_virus USING "
        "CASE "
        "  WHEN virus::text='TYPE0' "
        "  THEN 'CROSS'::player_virus "
        "  ELSE 'ZERO'::player_virus "
        "END"
    ))
    op.execute("DROP TYPE virus_type")

    op.alter_column('cell', 'content', nullable=False)
    op.drop_constraint('total_players_number_check', 'game', type_='check')
    op.drop_column('game', 'total_players_number')
    op.drop_column('cell', 'is_captured')
    op.drop_column('cell', 'owner_id')
    # ### end Alembic commands ###
